/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

#ifndef __B_HPP__
 #define __B_HPP__

#include "../a.hpp"  //  

//  B,    
class B {
      A a;

      void privF() { a.f(); }
 public:
      B(int i) : a(i) {}
      B(const B& b) : a(b.a) {}
      B& operator=(const B& b) { a=b.a; return *this; }
      ~B() { a.preDestr(); }

      void f() { privF(); }
};

#endif
 
