/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

#include <stdio.h>

typedef struct A* APtr;
void f(APtr&)       { puts("f(APtr&)"); }
void f(const APtr&) { puts("f(const APtr&)"); }

struct A { void g() { f(this); } };

int main()
{
 A a;
 a.g();  //  f(const APtr&)
}

